import 'package:cached_network_image/cached_network_image.dart';
import 'package:flutter/material.dart';
import 'package:heroes_companion/models/overflow_choices.dart';
import 'package:heroes_companion/routes.dart';
import 'package:heroes_companion/i18n/strings.dart';

//TODO Make this scroll well: https://github.com/flutter/flutter/issues/13604
class AppDrawer extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return new Drawer(
      child: new Column(
        children: <Widget>[
          new DrawerHeader(
              decoration: new BoxDecoration(
                color: Theme.of(context).primaryColor,
                image: new DecorationImage(
                  image: new CachedNetworkImageProvider('https://images.heroescompanion.com/banner.jpg'),
                  fit: BoxFit.cover,
                  colorFilter:
                    new ColorFilter.mode(Colors.black38, BlendMode.darken),
                )
              ),
              child: new Row(
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                crossAxisAlignment: CrossAxisAlignment.end,
                children: <Widget>[
                  new Text(
                    'Heroes Companion',
                    style: Theme
                        .of(context)
                        .textTheme
                        .title
                        .apply(color: Colors.white),
                  ),
                  // new Text('Patch 3.0', style: Theme.of(context).textTheme.body1.apply(color: Colors.white),)
                ],
              )),
          new ListTile(
            leading: new Icon(Icons.supervisor_account),
            title: new Text(AppStrings.of(context).heroes()),
            onTap: () {
              Navigator.popAndPushNamed(context, Routes.home);
            },
          ),
          // new ListTile(
          //   leading: new Icon(Icons.dashboard),
          //   title: new Text('Maps'),
          //   // onTap: () {
          //   //   Navigator.of(context).pop();
          //   //   Navigator.of(context).pushNamed(Routes.maps);
          //   // },
          // ),
          const Divider(),
          new ListTile(
            leading: const Icon(Icons.settings),
            title: new Text(
              AppStrings.of(context).settings(),
            ),
            onTap: () => Navigator.popAndPushNamed(context, Routes.settings),
          ),
          new ListTile(
            leading: const Icon(Icons.report),
            title: new Text(AppStrings.of(context).sendFeedback()),
            onTap: () =>
                OverflowChoice.handleChoice(OverflowChoice.Feedback, context),
          )
        ],
      ),
    );
  }
}
